<template>
  <q-page class="q-pa-md ">

    <!--BIG + button-->
    <div v-if="!items.length" class="big-plus-cont" >
      <q-btn
        @click="addDir"
        class="op-50"
        size="35px"
        round
        flat
        text-color="grey-5"
        icon="create_new_folder"
      />
    </div>

    <transition
      enter-active-class="animated fadeIn"
      leave-active-class="animated fadeOut"
    >
      <div v-if="can_select" class="fixed-top"
           style="z-index: 1;max-width: 600px;padding: 10px 20px; margin: 50px auto;">
        <q-banner rounded dense inline-actions class="text-white bg-secondary text-center">
          <q-btn flat color="white" label="Select / unselect all"/>
          <q-btn flat color="white" label="Delete selected 7 from 27"/>
          <q-btn @click="can_select = !can_select" flat color="white" label="Cancel"/>

          <!--<template v-slot:action>
            <q-btn flat color="white" label="Turn ON Wifi" />
          </template>-->
        </q-banner>
      </div>
    </transition>

    <!--size slider and dir info-->
    <div v-if="items.length" class="flex items-center">
      <div class="self-start text-grey-8">
        {{selected_path}} - ({{items.length}} files)
      </div>
      <q-space />
      <div style="width: 135px;" class="op-50">
        <q-slider v-model="max_size_px" :min="100" :max="435" color="secondary"/>
      </div>

    </div>

    <!--progress-->
    <div class="column q-mb-lg" v-if="loadingProgress.show">
      <div class=" text-secondary">
        {{ loadingProgress.complete === 0 || loadingProgress.complete !== loadingProgress.total ?
        `Loading... ${loadingProgress.complete} / ${loadingProgress.total}` : `Completed!`}}
      </div>
      <q-linear-progress dark
                         :value="loadingProgress.complete === 0 ? 0 : loadingProgress.complete / loadingProgress.total"
                         color="secondary"/>
    </div>

    <ul v-if="items.length"
        class="ul-media-list" :style="`grid-template-columns: repeat(auto-fill, minmax(${max_size_px}px, 1fr))`">
      <li v-for="(item, index) in items">
        <div
          @click="showItem(item, index)"
          class="media-item" :style="`height:${max_size_px * (224 / 450)}px`">
          <div class="photo"
               :style="`
                background: url(${static_files_url}/small/${item.filename}${item.file_type == 'video'? '.jpg' : ''}) no-repeat center / contain;`">
            <div class="controls">
              <!--checker-->
            </div>
          </div>
        </div>
      </li>
    </ul>

    <!--open media item-->
    <div class="opened-media-cont column" v-if="Object.keys(showingItem).length">
      <Pano  :type="showingItem.file_type" :source="showingItem.big_fileUrl" />
      <div class="head-actions">
        <q-btn
          @click="showingItem ={}"
          class="op-50" flat color="grey-7" text-color="grey-4" icon="close" size="20px" />
      </div>
      <div
        v-if="items[showingItem.index - 1]"
        class="op-50" style="position: absolute;left: 0; top: calc(50% - 25px);">
        <q-btn
          @click="showItem(items[showingItem.index - 1], showingItem.index - 1)"
          size="28px" flat color="grey-7" text-color="grey-4"  icon="arrow_back_ios"/>
      </div>
      <div
        v-if="items[showingItem.index + 1]"
        class="op-50" style="position: absolute;right: 0; top: calc(50% - 25px);">
        <q-btn
          @click="showItem(items[showingItem.index + 1], showingItem.index + 1)"
          size="28px" flat color="grey-7" text-color="grey-4"  icon="arrow_forward_ios"/>
      </div>
    </div>


  </q-page>
</template>

<script>
  import { Pano } from 'vuejs-vr'
  import {mapState} from 'vuex'


  export default {
    name: 'PageHome',
    components:{Pano},
    data() {
      return {
        selected_path: "",
        items: [],
        max_size_px: 150,
        selected: [],
        loadingProgress: {
          show: false,
          total: 0,
          complete: 0,
        },
        showingItemDialog: false,
        showingItem: {}
      }
    },
    computed: {
      can_select: {
        get() {
          return this.$store.state.can_select
        },
        set(val) {
          this.$store.commit("set", ['can_select', val])
        }
      },
      ...mapState(['MS', 'static_files_url'])
    },
    watch: {
      'can_select'(newVal, oldVal) {
        console.log(newVal)
      }
    },
    methods: {
      startReadDir(total) {
        this.$store.commit("set", ["can_open_dir", false])
        this.loadingProgress = {
          show: true,
          total,
          complete: 0,
        }
        this.items = []
      },
      finishReadDir(data) {
        setTimeout(() => {
          this.loadingProgress.show = false
          this.$store.commit("set", ["can_open_dir", true])
        }, 600)

        // console.log(data)
      },
      readFile(data) {
        this.loadingProgress.complete += 1
        console.log(data)

        if (data.error) {
          this.$q.notify({
            message: data.error,
            color: 'negative',
          })

          return
        }

        let tmp = _.cloneDeep(this.items)
        tmp.push(data)
        tmp = _.sortBy(tmp, ['filename'])
        this.items = tmp


        // this.items.push(data)
      },
      addDir(){
        if (!this.MS){
          this.$q.notify({
            message: 'Backend not ready or something went wrong...',
            color: 'warning',
            textColor: 'black'
          });
          return
        }

        this.MS.OpenDir().then(ev => {
          console.log("dir is opened", ev)

        }).catch(err => {
          this.$q.notify({
            message: err,
            color: 'negative',
            // textColor: 'black'
          });
        })

      },
      showItem(item, index){
        //todo не самое красивое решение, но тоже вариант. Правильно сразу сделать вывод из бкенда, чтобы не заниматься ерундой...
        let filename = item.file_type === "photo" ? item.filename : item.filename + ".mp4";
        item.big_fileUrl = this.static_files_url + "big/" + filename;
        this.showingItem = {
          ...item,
          index
        }
      }

    },
    created() {

      wails.Events.On("StartReadFiles", this.startReadDir)
      wails.Events.On("FinishReadFiles", this.finishReadDir)
      wails.Events.On("ReadFile", this.readFile)
      wails.Events.On("OpenDirPath", ev => this.selected_path = ev)

    }
  }
</script>
<style scoped lang="scss">
  @import "../styles/sht-styles";

  .ul-media-list {
    list-style: none;
    margin: 25px 0;
    padding: 0;
    display: grid;
    grid-gap: 10px;
    /*grid-template-columns: repeat(auto-fill, minmax(50px, 300px));*/

    & > li {
      border: 2px solid transparent;
      padding: 5px;

      &:hover {
        border-color: rgba($secondary, .5);
      }


      & > .media-item {
        display: flex;
        justify-content: center;
        align-items: center;
        position: relative;
        cursor: pointer;
        /*transition: all .2s ease;*/


        & > .photo {
          position: absolute;
          width: 100%;
          height: 100%;
          box-sizing: border-box;
        }
      }


    }
  }
  .big-plus-cont{
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  .opened-media-cont{
    //display: flex;
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: #1cff1b;
    z-index: 2001;

    &>.head-actions{
      position: absolute;
      right: 0;
      top: 0;
    }


  }
</style>